<?php
$rp='../classes/';

$test=false;
if ($test)
{
  require $rp.'Model.php';
  require 'Util.php';
  require $rp.'Parameter.php';
  require $rp.'Variable.php';
  require $rp.'Unit.php';
  require $rp.'Definition.php';
  require $rp.'AlgebraicRule.php';
  require $rp.'DifferentialRule.php';
  require $rp.'Event.php';
}
$variables=array();
$parameters=array();

$debug=true;
$model='';

function startDocument() {
     print "<html>\n";
     print "<body>\n";
}

function endDocument() {
     print "</body>\n";
     print "</html>\n";
 }


function readDatabase($filename) {
  global $model;
  $parser=xml_parser_create();
  //$data=implode("",file("NaClbBetter.xml"));
  $data=implode("",file($filename));
  xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING,false);
  xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
  xml_parse_into_struct($parser, $data,$values,$tags);
  xml_parser_free($parser);
  echo "Tableau d'index <P>";
  print_r($tags) ; 
  echo "<P>Tableau de valeurs \n";
  print_r($values) ; 
  foreach ($tags as $key=>$val) {
    if ($key== "head")
     { 
       $i=2;
       $modelName=$values[3]["value"];
       $modelType=$values[4]["value"];
       $date=$values[5]["value"];
       $author=$values[6]["value"];
       $version=$values[7]["value"];
       $bibliographie=$values[8]["value"];
       $description=$values[9]["value"];
       $independantVariable=$values[10]["value"];
       $organism=$values[11]["value"];
       $model=new Model();
       $GLOBALS["model"]->addInfo($modelName,$modelType,$date,
                        $author,$version,$bibliographie,$description,
                        $independantVariable,$organism);
    }
     if ($key== "modelVariables")
      {
         $begin=$tags[$key][0]+1;
         $end=$tags[$key][1];
         for ($i=$begin;$i<$end;$i++)
           {
             $modelTree= createVariable($values[$i]);
           }  
       }
     if ($key== "modelParameters")
      {
         $begin=$tags[$key][0]+1;
         $end=$tags[$key][1];
         for ($i=$begin;$i<$end;$i++)
           {
        $modelTree= createParameter($values[$i]);
           }
       }  
     if ($key== "modelDefinitions")
      {
         $begin=$tags[$key][0]+1;
         $end=$tags[$key][1];
         
         for ($i=$begin;$i<$end;$i+=3)
           {

              print ("<br> i=".$i."<br>");
              $formula=$i+1;
              $modelTree= createDefinition($values[$i],$values[$formula]);

          }
      }  
     if ($key== "listOfEvents")
      {
        $begin=$tags[$key][0]+1;
        $end=$tags[$key][1];
        for ($i=$begin;$i< $end;$i++)
           {
              $modelTree= createEvent($values[$i]);
          }
      }

    }
   print_r($model); 
   $model->printModel();
}

function createVariable($Tvalues) 
{

   $item=new Variable();
   $item->addInfo($Tvalues["attributes"]);
   $GLOBALS["model"]->addVariable($item);

}

function createParameter($Tvalues) 
{

   print_r($Tvalues);
   $item=new Parameter();
   $item->addInfo($Tvalues["attributes"]);
   $GLOBALS["model"]->addParameter($item);

}

function createEvent($Tvalues) 
{

   print_r($Tvalues);
   $item=new Event();
   $item->addInfo($Tvalues["attributes"]);
   $GLOBALS["model"]->addEvent($item);

}

function createDefinition($Tvalues,$equation) 
{
 
         print("<br> definition");
         print_r($Tvalues);

	  if ($Tvalues["tag"]=="definition")
           {
             echo"<br>";
             $formula=$equation["attributes"]["equation"];
             print ("<br>equation <br>".$formula."<br>"); 
             $item=new Definition();
	     $item->addInfo($Tvalues["attributes"]);
             $item->addEquation($formula);
	     $GLOBALS["model"]->addDefinition($item);

	   }
	  if ($Tvalues["tag"]=="differentialModel")
           {
             echo"<br>";

             $formula=$equation["attributes"]["equation"];
             print ("<br>equation diff <br>".$formula."<br>"); 

             $item=new DifferentialRule();
	     $item->addInfo($Tvalues["attributes"]);
            
             $item->addEquation($formula);
	     $GLOBALS["model"]->addDefinition($item);
	    
	   }
	  if ($Tvalues["tag"]=="algebraicModel")
           {
             echo"<br>";

             $formula=$equation["attributes"]["equation"];
             print ("<br>equation <br>".$formula."<br>"); 

             $item=new AlgebraicRule();
	     $item->addInfo($Tvalues["attributes"]);
             $item->addEquation($formula);
	     $GLOBALS["model"]->addDefinition($item);
	    
	   }
  
}



if($test)
{
  echo '<html><head></head><body>';
  $db = readDatabase("NaclbBetter.xml");
  echo "**Model NaClbBetter:\n";
}
?>
