<?php

/* no abstract keyword in php 4 but exist abstract in php 5 */

class Definition
{
  var $label;
  var $comment;
  var $equation;  
  var $listOfParameters; 
  var $listOfVariables;  // ref array 
  var $sbml_tag ;
  
  function Definition() { 
    $this->label='';
    $this->comment='';
    $this->equation='';  
    $this->listOfParameters=null; 
    $this->listOfVariables=null;  
    $this->sbml_tag_begin="<definition>" ;
    $this->sbml_tag_end="</definition>" ;
 
    }

  function setDefinition($label,$comment,$equation) { 
    $this->label=$label;
    $this->comment=$comment;
    $this->equation=$equation;  
    }

 
  function addInfo($tab) { 
    print("addInfo Definition");
    $this->label=$tab["label"];
    $this->comment=$tab["comment"];
    $this->equation=$tab["equation"];
    $this->listOfParameters=$tab["listOfParameters"];
    $this->listOfVariables=$tab["listOfVariables"];
  }

  function addEquation($equation){
	
    $this->equation=$equation;
  }

  function save(){
    $contents=$this->sbml_tag_begin.$this->label.
              $this->equation.$this->listOfParameters.
	      $this->listOfVariables.$this->comment.
	      $this->sbml_tag_end;
    return $contents;
  }

  function setLOP($id,$par){$this->listOfParameters[$id]=$par;}
  function getLOP($id){return $this->listOfParameters[$id];}

  function setLOV($id,$val){$this->listOfVariables[$id]=&$val;}
  function getLOV($id){return $this->listOfVariables[$id];}
} 


?>