<?php

class Model
{
  var $modelType='';
  var $date='';
  var $author='';
  var $version='';
  var $name='';
  var $bibliography=''; 
  var $description=''; // comment
  var $organism='';  
  var $daeml_tag_begin="<xml><model>"; 
  var $daeml_tag_begin="</model></xml>"; 
  var $independentVariable=''; // will be a ref  to a Var  
  var $listOfParameters=null;
  var $listOfVariables=null;
  var $listOfDefinitions=null;    
  var $listOfUnits=null; 
  var $listOfEvents=null;

  function printModel()
   {

      print("<br>");
        print("New Model");
	print ($this->author);
	print ($this->date);
	print ($this->modelType);
        print("<br>Variables<br>");
    foreach ($this->listOfVariables as $key=>$val)
     { 
       print($val->name);
       print("<br>");

     }
      print("<br>");

      print("<br> Parameters<br>");
    foreach ($this->listOfParameters as $key=>$val)
     { 
       print($val->name);
       print("<br>");
 
    }
      print("<br>");
    }


  
  function Model()
  {
   $this->modelType=" ";
   $this->date="";
   $this->author="";
   $this->version="";
   $this->name="";
   $this->bibliography=""; 
   $this->description=""; 
   $this->organism=""; 
   $daeml_tag_begin="<xml><model>"; 
   $daeml_tag_begin="</model></xml>"; 

   $this->independentVariable="";  
   $this->listOfParameters=array();
   $this->listOfVariables=array();
   $this->listOfDefinitions=array();    
   $this->listOfUnits=array(); 
   $this->listOfEvents=array(); 
  }

  
  function addInfo($modelName,$modelType,$date,$author,$version,$bibliographie,$description,$independantVariable,$organism)
  {
   print($modelName);
   $this->name=$modelName;
   $this->modelType=$modelType;
   $this->author=$author;
   $this->version=$version;
   $this->date=$date;
   $this->bibliography=$bibliography; 
   $this->description=$description; 
   $this->organism=$organism; 

   $this->independentVariable=$independantVariable;  
   $this->listOfParameters=array();
   $this->listOfVariables=array();
   $this->listOfDefinitions=array();    
   $this->listOfUnits=array(); 
   $this->listOfEvents=array(); 
   print("Go to addINfo Model");
   $this->printModel();
  }
  //  'equality' must be redef in class 
  // for obj to compare to one another 
 
  function addVariable($variable)
  {
    foreach ($this->listOfVariables as $key=>$val)
     { 
       if ($variable->name == $val->name)
	 {$this->listOfVariables[$key]=$variable;$f=1;}
     }
    if ($f!=1){$this->listOfVariables[]=$variable;}
  }

    function removeVariable($numview)
  {
    unset($this->listOfVariables[$numview]);
  }

   function removeParameter($numview)
  {
    unset($this->listOfParameters[$numview]);;
  }

   function removeEvent($numview)
  {
    unset($this->listOfEvents[$numview]);;
  }

   function removeDefinition($numview)
  {
    unset($this->listOfDefinitions[$numview]);;
  }

  function addParameter($parameter)
  {
    foreach ($this->listOfParameters as $key=>$par)
     { 
       if ($parameter->name == $par->name)
	 {$this->listOfParameters[$key]=$parameter;$f=1;}
     }
    if ($f!=1){
      $this->listOfParameters[]=$parameter;}
  }
  function addDefinition($definition) 
  { 
    foreach ($this->listOfDefinitions as $key=>$def)
      { 
	if (is_a($def,get_class($definition)))
	  {	    
	    if ($definition->label == $def->label && $definition->variableRef==$def->variableRef ) 
	      {$this->listOfDefinitions[$key]=$definition;$f=1;}	    
	  }
      }
    if ($f!=1){
      $this->listOfDefinitions[]=$definition;}         
  }

  function addUnit($unit)
  {
     foreach ($this->listOfUnits as $key=>$uni)
     { 
       if ($unit->name == $uni->name)
	 {$this->listOfUnits[$key]=$unit;$f=1;}
     }
    if ($f!=1){
      $this->listOfUnits[]=$unit;}
  }
  function addEvent($event)
  {
      foreach ($this->listOfEvents as $key=>$eve)
     { 
       if ($event->label == $eve->label)
	 {$this->listOfEvents[$key]=$eve;$f=1;}
     }
    if ($f!=1){
      $this->listOfEvents[]=$event;}
  }


  function save(){
    $contents=$this->sbml_tag_begin.$this->modelType.$this->date.$this->author.$this->version.$this->name.$this->bibliography.$this->description.$this->organism.$this->independentVariable;
    foreach ( $this->listOfParameters as $param)
    {$contents.=$param->save(); }  
    foreach ( $this->listOfVariables as $param)
    {$contents.=$param->save(); }
    foreach ( $this->listOfDefinitions as $param)
    {$contents.=$param->save(); }
  
    foreach ( $this->listOfUnits as $param)
    {$contents.=$param->save(); }

    foreach ( $this->listOfEvents as $param)
    {$contents.=$param->save(); }

    $contents.=$this->sbml_tag_end;
 
    return $contents;
  }



  function setindepedentVariable($val){$this->independentVariable=$val;} 
  function getindepedentVariable(){return $this->independentVariable;} 
  // function getindepedentVariable($id){return $this->independentVariable[$id];} 
  
  function setlistOfParameters($val){$this->listOfParameters=$val;}
  function getlistOfParameters(){return $this->listOfParameters;}
  // function getlistOfParameters($id){return $this->listOfParameters[$id];}

  function setlistOfUnits($val){$this->listOfUnits=$val;}
  function getlistOfUnits(){return $this->listOfUnits;}

  function setlistOfVariables($id,$val){$this->listOfVariables[$id]=$val;}
  function getlistOfVariables(){return $this->listOfVariables;}  

  function setlistOfDefinitions($id,$val){$this->listOfDefinitions[$id]=$val;}
  function getlistOfDefinitions(){return $this->listOfDefinitions;}

   function setlistOfEvents($id,$val){$this->listOfEvents[$id]=$val;}
  function getlistOfEvents(){return $this->listOfEvents;}
  
  function toHTML() // redef in each class
  {
    $html="";
    /* ... */
    return $html;
  }

  function exportdaeML($handler)  // some choices to make in xsd to be fully 
  {                     // compliant with ourself =)
    /* Head */ 
    $xml="";
    $xml.="<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>";
    $xml.="<Model>";
    $xml.="<HEAD";  // prob in fact, element not attributes
    $xml.=" Name=\"".$this->name."\"";
    $xml.=" ModelType=\"".$this->type."\"";
    $xml.=" ModelAuthor=\"".$this->author."\"";
    $xml.=" ModelVersion=\"".$this->version."\"";
    $xml.=" ModelDate=\"".$this->date."\"";
    $xml.=" ModelReference=\"".$this->reference."\"";
    $xml.=" ModelDescription=\"".$this->description."\"";
    $xml.=" Organism=\"".$this->organism."\"";  
    $xml.= "/>";    
    reset($this->listOfParameters);
    foreach ($this->listOfParameters as $param){
      $xml.= $param->exportXML();
    }
    reset($this->listOfVariables);
    foreach ($this->listOfVariables as $variable){
      $xml.= $variable->exportXML();
    }
    reset($this->listOfDefinitions);
    foreach ($this->listOfDefinitions as $def){
      $xml.= $def->exportXML();
    }
    reset($this->listOfUnits);
    foreach ($this->listOfUnits as $unit){
      $xml.= $unit->exportXML();
    }
    
    $xml.="</Model>";
    return $xml;
  }  
  
  function serialize($filename)
  {
    $s = serialize($this);
    $fp = fopen($filename, "w");
    fwrite($fp, $s);
    fclose($fp);
  }

  function unserialize($filename)
  {
    $s = implode("", @file($filename));
    $this = unserialize($s);
  }
}

?>
